function writeToSpan(text){
	console.log(text);
	console.log("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
};

//mothod 1: brodcast channel using
// Connection to a broadcast channel
const bc = new BroadcastChannel('ExchangeChannel'); // using the same channed to exchange between CRM and OneAgentWeb, need to define src=oaw or src=crm

// subsribe on event to catch the received message
	bc.onmessage = (event) => { 
		writeToSpan("receive message.data:"+event.data); 
		var msg = JSON.parse(event.data);
		typeof(msg) ===  'object';
		writeToSpan("receive message from src: "+msg.src+", at: "+msg.tm+"."); 
        switch (msg.src) {
                    case "oaw":
                        switch (msg.type) {
							case "popup":
								popupInCRM(msg.ani,msg.dnis, msg.serviceid, msg.servicename)
								break;
							case "other":
								// call other function();
								break;
							default:
								writeToSpan("receive message with external type "+msg.type+"."); 
							 break;
						}
						break;
                    case "crm":
						switch (msg.type) {
							case "makecall":
								makecallOAW(msg.ani, msg.serviceid, msg.dnis)
								break;
							case "other":
								// call other function();
								break;
							default:
								writeToSpan("receive message with external type: "+msg.type+"."); 
							 break;
						}
						break;
					default:
						writeToSpan("receive message from external src: "+msg.src+"."); 
					 break;
                }
	   
		writeToSpan("makeSDKCall(tel) is called with tel:"+msg.tel);
	};
	

function popupInCRM(ani,dnis, serviceid, servicename){
    var tel = "";

    if (ani.substring(0,3) == "+33") { 
        tel = "0" + ani.substring(3,ani.length);
    } else {
        tel = ani;
    }
      let confirmAction = confirm("A new call established and contact popup will be opened, do you want cancel that and to stay on this page?");
      if (confirmAction) {
            writeToSpan("popupInCRM canceled function( ani=>tel:"+tel+", dnis:"+dnis+", serviceid:"+serviceid+", servicename:"+servicename+")");
      } else {
            document.getElementById('query_string').value=tel;
            document.forms["searchformdropdown"].submit();
            writeToSpan("popupInCRM end function( ani=>tel:"+tel+", dnis:"+dnis+", serviceid:"+serviceid+", servicename:"+servicename+")");
      }
    
    //document.getElementById('query_string').value=tel;
    //document.forms["searchformdropdown"].submit();
    //writeToSpan("popupInCRM end function( ani=>tel:"+tel+", dnis:"+dnis+", serviceid:"+serviceid+", servicename:"+servicename+")");
}	

function makeCallFromCrm(ani,dnis, serviceid, servicename){
	var msg= "{\"src\":\"crm\",\"type\":\"makecall\",\"ani\":\""+ani+"\",\"dnis\":\""+dnis+"\",\"serviceid\":\""+serviceid+"\",\"servicename\":\""+servicename+"\"}";
	writeToSpan("makeCallFromCrm message: "+msg+".");
    bc.postMessage(msg);
    writeToSpan("makeCallFromCrm end function( from:"+dnis+", to:"+ani+", serviceid:"+serviceid+", servicename:"+servicename+")");
	// generate the event with the message
    //Window.localStorage.setItem("data", msg);
}

function interceptClickEvent(e) {
    var href;
    var target = e.target || e.srcElement;
    if (target.tagName === 'A') {
        href = target.getAttribute('href');

        //put your logic here...
        if (href.indexOf("tel:") == 0 ) {
			makeCallFromCrm(href.substring(4,href.length),"", "", "");
           href=
            //tell the browser not to respond to the link click
            e.stopImmediatePropagation()
            e.preventDefault();
            e.returnValue = false;
            /*
            e.stopPropagation();
            //e.doDefault();
            if (e.preventDefault){ 
                e.preventDefault();
            } 
            else { 
                e.returnValue = true; 
            }
            */
           
        }
    }
}

function readyStateValue(e) {
    writeToSpan("readyStateValue: "+ e.toString() +"."); 
    
}

//listen for link click events at the document level
if (document.addEventListener) {
    document.addEventListener('click', interceptClickEvent);
    document.addEventListener('readystatechange', readyStateValue);
} else if (document.attachEvent) {
    document.attachEvent('onclick', interceptClickEvent);
    document.addEventListener('onreadystatechange', readyStateValue);
}

let stateCheck = setInterval(() => {
    if (document.readyState === 'complete') {
        //clearInterval(stateCheck);
        //if (myLocation != window.location.href ) {  
             if(document.getElementsByClassName('MakeCall')[0] == undefined) {
                clearInterval(stateCheck);
                readyStateTraitement();
        //    }
            
        } else {
            writeToSpan("stateCheck, myLocation: "+ window.location.href +"."); 
        }
    }
}, 1000);



window.onhashchange = locationHashChanged;
function locationHashChanged( e ) {
    writeToSpan("locationHashChanged try reload, e.newURL: "+ e.newURL +", e.oldURL: "+ e.oldURL +"."); 
    if(e.newURL != 'https://'+window.location.hostname+'/index.php?action=ajaxui#') window.location.reload();
}



var phoneList = "vide";
var makeCallList = "vide";

function readyStateTraitement(){
//writeToSpan("readyState complete: enter."); 

        // alert ('readyState complete.');   
        phoneList = document.getElementsByClassName("phone");
        makeCallList = document.getElementsByClassName("MakeCall");
        
        writeToSpan("readyState complete, phoneList.length: "+ phoneList.length +"."); 
   
        for(var i = 0; i < phoneList.length; i++)
        {   if (phoneList[i].getElementsByTagName('A')[0] == undefined) break;
            
            var tel = phoneList[i].getElementsByTagName('A')[0].href.substring(4,phoneList[i].getElementsByTagName('A')[0].href.length);
            var tel2 = phoneList[i].getElementsByTagName('A')[0].innerText;
          
            writeToSpan("readyState complete, phoneList.["+ i +"] A:=> "+phoneList[i].getElementsByTagName('A')[0]); 
            writeToSpan("readyState complete, phoneList.["+ i +"] T:=> "+tel+" / "+tel2); 
            

            var btnElement = document.createElement('BUTTON');
            btnElement.type = "button";
            btnElement.innerHTML = "MakeCall";
            btnElement.className="MakeCall btn-danger btn-xs"

            btnElement.setAttribute('onclick', "makeCallFromCrm("+tel+",'', '', '')");
            phoneList[i].insertBefore(btnElement, phoneList[i].firstChild);
            writeToSpan("readyState complete, phoneList.["+ i +"] C:=> "+btnElement.onclick);

            phoneList[i].getElementsByTagName('A')[0].removeAttribute("href");
            //phoneList[i].getElementsByTagName('A')[0].href="#";
            ////phoneList[i].appendChild(btnElement);
        }
        
};
